diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/src/java.base/unix/native/libnio/ch/NativeThread.c jdk18u-jdk-18.0.2.1-ga/src/java.base/unix/native/libnio/ch/NativeThread.c
--- jdk18u-jdk-18.0.2.1-ga.orig/src/java.base/unix/native/libnio/ch/NativeThread.c	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/src/java.base/unix/native/libnio/ch/NativeThread.c	2024-08-17 18:29:44.502566358 +0200
@@ -40,6 +40,9 @@
 #elif defined(_AIX)
   /* Also defined in net/aix_close.c */
   #define INTERRUPT_SIGNAL (SIGRTMAX - 1)
+#elif defined(__solaris__)
+  #include <thread.h>
+  #define INTERRUPT_SIGNAL (SIGRTMAX - 2)
 #elif defined(_ALLBSD_SOURCE)
   /* Also defined in net/bsd_close.c */
   #define INTERRUPT_SIGNAL SIGIO
@@ -74,14 +77,22 @@
 JNIEXPORT jlong JNICALL
 Java_sun_nio_ch_NativeThread_current(JNIEnv *env, jclass cl)
 {
+#ifdef __solaris__
+    return (jlong)thr_self();
+#else
     return (jlong)pthread_self();
+#endif
 }
 
 JNIEXPORT void JNICALL
 Java_sun_nio_ch_NativeThread_signal(JNIEnv *env, jclass cl, jlong thread)
 {
     int ret;
+#ifdef __solaris__
+    ret = thr_kill((thread_t)thread, INTERRUPT_SIGNAL);
+#else
     ret = pthread_kill((pthread_t)thread, INTERRUPT_SIGNAL);
+#endif
 #ifdef MACOSX
     if (ret != 0 && ret != ESRCH)
 #else
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/src/java.base/unix/native/libnio/ch/Net.c jdk18u-jdk-18.0.2.1-ga/src/java.base/unix/native/libnio/ch/Net.c
--- jdk18u-jdk-18.0.2.1-ga.orig/src/java.base/unix/native/libnio/ch/Net.c	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/src/java.base/unix/native/libnio/ch/Net.c	2024-08-17 18:29:44.503172913 +0200
@@ -170,7 +170,7 @@
 JNIEXPORT jboolean JNICALL
 Java_sun_nio_ch_Net_canIPv6SocketJoinIPv4Group0(JNIEnv* env, jclass cl)
 {
-#if defined(__linux__) || defined(__APPLE__)
+#if defined(__linux__) || defined(__APPLE__) || defined(__solaris__)
     /* IPv6 sockets can join IPv4 multicast groups */
     return JNI_TRUE;
 #else
@@ -182,7 +182,7 @@
 JNIEXPORT jboolean JNICALL
 Java_sun_nio_ch_Net_canJoin6WithIPv4Group0(JNIEnv* env, jclass cl)
 {
-#if defined(__APPLE__)
+#if defined(__APPLE__) || defined(__solaris__)
     /* IPV6_ADD_MEMBERSHIP can be used to join IPv4 multicast groups */
     return JNI_TRUE;
 #else
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/src/java.base/unix/native/libnio/ch/nio_util.h jdk18u-jdk-18.0.2.1-ga/src/java.base/unix/native/libnio/ch/nio_util.h
--- jdk18u-jdk-18.0.2.1-ga.orig/src/java.base/unix/native/libnio/ch/nio_util.h	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/src/java.base/unix/native/libnio/ch/nio_util.h	2024-08-17 18:29:44.503568527 +0200
@@ -41,6 +41,8 @@
 #ifndef SO_REUSEPORT
 #ifdef __linux__
 #define SO_REUSEPORT 15
+#elif defined(__solaris__)
+#define SO_REUSEPORT 0x100e
 #elif defined(AIX) || defined(MACOSX)
 #define SO_REUSEPORT 0x0200
 #else
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/src/java.base/unix/native/libnio/fs/UnixNativeDispatcher.c jdk18u-jdk-18.0.2.1-ga/src/java.base/unix/native/libnio/fs/UnixNativeDispatcher.c
--- jdk18u-jdk-18.0.2.1-ga.orig/src/java.base/unix/native/libnio/fs/UnixNativeDispatcher.c	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/src/java.base/unix/native/libnio/fs/UnixNativeDispatcher.c	2024-08-17 18:29:44.504282601 +0200
@@ -45,10 +45,17 @@
 #include <sys/xattr.h>
 #endif
 
-/* For POSIX-compliant getpwuid_r */
+/* For POSIX-compliant getpwuid_r, getgrgid_r on Solaris */
+#if defined(__solaris__)
+#define _POSIX_PTHREAD_SEMANTICS
+#endif
 #include <pwd.h>
 #include <grp.h>
 
+#ifdef __solaris__
+#include <strings.h>
+#endif
+
 #ifdef __linux__
 #include <sys/syscall.h>
 #endif
@@ -260,7 +267,8 @@
 
     /* system calls that might not be available at run time */
 
-#if defined(_ALLBSD_SOURCE)
+#if (defined(__solaris__) && defined(_LP64)) || defined(_ALLBSD_SOURCE)
+    /* Solaris 64-bit does not have openat64/fstatat64 */
     my_openat64_func = (openat64_func*)dlsym(RTLD_DEFAULT, "openat");
     my_fstatat64_func = (fstatat64_func*)dlsym(RTLD_DEFAULT, "fstatat");
 #else
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/src/java.base/windows/native/libnet/net_util_md.c jdk18u-jdk-18.0.2.1-ga/src/java.base/windows/native/libnet/net_util_md.c
--- jdk18u-jdk-18.0.2.1-ga.orig/src/java.base/windows/native/libnet/net_util_md.c	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/src/java.base/windows/native/libnet/net_util_md.c	2024-08-17 18:29:44.504946014 +0200
@@ -127,6 +127,7 @@
 }
 
 void platformInit() {}
+void parseExclusiveBindProperty(JNIEnv *env) {}
 
 /*
  * Since winsock doesn't have the equivalent of strerror(errno)
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/src/java.desktop/share/classes/sun/awt/FontConfiguration.java jdk18u-jdk-18.0.2.1-ga/src/java.desktop/share/classes/sun/awt/FontConfiguration.java
--- jdk18u-jdk-18.0.2.1-ga.orig/src/java.desktop/share/classes/sun/awt/FontConfiguration.java	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/src/java.desktop/share/classes/sun/awt/FontConfiguration.java	2024-08-17 18:29:44.505998508 +0200
@@ -1429,6 +1429,22 @@
                 }
             }
         }
+        if ("SunOS".equals(osName)) {
+            for (int ii = 0; ii < table_awtfontpaths.length; ii++) {
+                if (table_awtfontpaths[ii] == 0) {
+                    String script = getString(table_scriptIDs[ii]);
+                    if (script.contains("dingbats") ||
+                        script.contains("symbol")) {
+                        continue;
+                    }
+                    System.err.println("\nError: "
+                                       + "<awtfontpath."
+                                       + script
+                                       + "> entry is missing!!!");
+                    errors++;
+                }
+            }
+        }
         if (errors != 0) {
             System.err.println("!!THERE ARE " + errors + " ERROR(S) IN "
                                + "THE FONTCONFIG FILE, PLEASE CHECK ITS CONTENT!!\n");
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/src/java.desktop/share/classes/sun/awt/OSInfo.java jdk18u-jdk-18.0.2.1-ga/src/java.desktop/share/classes/sun/awt/OSInfo.java
--- jdk18u-jdk-18.0.2.1-ga.orig/src/java.desktop/share/classes/sun/awt/OSInfo.java	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/src/java.desktop/share/classes/sun/awt/OSInfo.java	2024-08-17 18:29:44.506504771 +0200
@@ -38,6 +38,7 @@
     public static enum OSType {
         WINDOWS,
         LINUX,
+        SOLARIS,
         MACOSX,
         AIX,
         UNKNOWN
@@ -99,6 +100,10 @@
                 return LINUX;
             }
 
+            if (osName.contains("Solaris") || osName.contains("SunOS")) {
+                return SOLARIS;
+            }
+
             if (osName.contains("OS X")) {
                 return MACOSX;
             }
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/src/java.desktop/share/classes/sun/font/CMap.java jdk18u-jdk-18.0.2.1-ga/src/java.desktop/share/classes/sun/font/CMap.java
--- jdk18u-jdk-18.0.2.1-ga.orig/src/java.desktop/share/classes/sun/font/CMap.java	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/src/java.desktop/share/classes/sun/font/CMap.java	2024-08-17 18:29:44.507238168 +0200
@@ -234,8 +234,26 @@
                                   getConverterMap(GBKEncoding));
             }
             else if (three4 != 0) {
-                cmap = createCMap(cmapBuffer, three4,
-                                  getConverterMap(Big5Encoding));
+                /* GB2312 TrueType fonts on Solaris have wrong encoding ID for
+                 * cmap table, these fonts have EncodingID 4 which is Big5
+                 * encoding according the TrueType spec, but actually the
+                 * fonts are using gb2312 encoding, have to use this
+                 * workaround to make Solaris zh_CN locale work.  -sherman
+                 */
+                if (FontUtilities.isSolaris && font.platName != null &&
+                    (font.platName.startsWith(
+                     "/usr/openwin/lib/locale/zh_CN.EUC/X11/fonts/TrueType") ||
+                     font.platName.startsWith(
+                     "/usr/openwin/lib/locale/zh_CN/X11/fonts/TrueType") ||
+                     font.platName.startsWith(
+                     "/usr/openwin/lib/locale/zh/X11/fonts/TrueType"))) {
+                    cmap = createCMap(cmapBuffer, three4,
+                                       getConverterMap(GBKEncoding));
+                }
+                else {
+                    cmap = createCMap(cmapBuffer, three4,
+                                      getConverterMap(Big5Encoding));
+                }
             }
             else if (three5 != 0) {
                 cmap = createCMap(cmapBuffer, three5,
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/src/java.desktop/share/classes/sun/font/FileFont.java jdk18u-jdk-18.0.2.1-ga/src/java.desktop/share/classes/sun/font/FileFont.java
--- jdk18u-jdk-18.0.2.1-ga.orig/src/java.desktop/share/classes/sun/font/FileFont.java	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/src/java.desktop/share/classes/sun/font/FileFont.java	2024-08-17 18:29:44.507751944 +0200
@@ -76,6 +76,8 @@
      * the native path, since fonts have contiguous zero-based glyph indexes,
      * and these obviously do all exist in the font.
      */
+    protected boolean checkedNatives;
+    protected boolean useNatives;
     protected NativeFont[] nativeFonts;
     protected char[] glyphToCharMap;
     /*
@@ -88,9 +90,17 @@
     }
 
     FontStrike createStrike(FontStrikeDesc desc) {
+        if (!checkedNatives) {
+           checkUseNatives();
+        }
         return new FileFontStrike(this, desc);
     }
 
+    protected boolean checkUseNatives() {
+        checkedNatives = true;
+        return useNatives;
+    }
+
     /* This method needs to be accessible to FontManager if there is
      * file pool management. It may be a no-op.
      */
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/src/java.desktop/share/classes/sun/font/FileFontStrike.java jdk18u-jdk-18.0.2.1-ga/src/java.desktop/share/classes/sun/font/FileFontStrike.java
--- jdk18u-jdk-18.0.2.1-ga.orig/src/java.desktop/share/classes/sun/font/FileFontStrike.java	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/src/java.desktop/share/classes/sun/font/FileFontStrike.java	2024-08-17 18:29:44.508339421 +0200
@@ -222,6 +222,24 @@
             !((TrueTypeFont)fileFont).useEmbeddedBitmapsForSize(intPtSize)) {
             useNatives = true;
         }
+        else if (fileFont.checkUseNatives() && desc.aaHint==0 && !algoStyle) {
+            /* Check its a simple scale of a pt size in the range
+             * where native bitmaps typically exist (6-36 pts) */
+            if (matrix[1] == 0.0 && matrix[2] == 0.0 &&
+                matrix[0] >= 6.0 && matrix[0] <= 36.0 &&
+                matrix[0] == matrix[3]) {
+                useNatives = true;
+                int numNatives = fileFont.nativeFonts.length;
+                nativeStrikes = new NativeStrike[numNatives];
+                /* Maybe initialise these strikes lazily?. But we
+                 * know we need at least one
+                 */
+                for (int i=0; i<numNatives; i++) {
+                    nativeStrikes[i] =
+                        new NativeStrike(fileFont.nativeFonts[i], desc, false);
+                }
+            }
+        }
         if (FontUtilities.isLogging() && FontUtilities.isWindows) {
             FontUtilities.logInfo("Strike for " + fileFont + " at size = " + intPtSize +
                  " use natives = " + useNatives +
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/src/java.desktop/share/classes/sun/font/FontUtilities.java jdk18u-jdk-18.0.2.1-ga/src/java.desktop/share/classes/sun/font/FontUtilities.java
--- jdk18u-jdk-18.0.2.1-ga.orig/src/java.desktop/share/classes/sun/font/FontUtilities.java	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/src/java.desktop/share/classes/sun/font/FontUtilities.java	2024-08-17 18:29:44.508893407 +0200
@@ -40,6 +40,8 @@
  */
 public final class FontUtilities {
 
+    public static boolean isSolaris;
+
     public static boolean isLinux;
 
     public static boolean isMacOSX;
@@ -65,6 +67,7 @@
             @Override
             public Object run() {
                 String osName = System.getProperty("os.name", "unknownOS");
+                isSolaris = osName.startsWith("SunOS");
 
                 isLinux = osName.startsWith("Linux");
 
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/src/java.desktop/share/classes/sun/font/SunFontManager.java jdk18u-jdk-18.0.2.1-ga/src/java.desktop/share/classes/sun/font/SunFontManager.java
--- jdk18u-jdk-18.0.2.1-ga.orig/src/java.desktop/share/classes/sun/font/SunFontManager.java	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/src/java.desktop/share/classes/sun/font/SunFontManager.java	2024-08-17 18:29:44.510340896 +0200
@@ -442,6 +442,24 @@
                     registerFontDirs(extraFontPath);
                 }
 
+                /* On Solaris, we need to register the Japanese TrueType
+                 * directory so that we can find the corresponding
+                 * bitmap fonts. This could be done by listing the
+                 * directory in the font configuration file, but we
+                 * don't want to confuse users with this quirk. There
+                 * are no bitmap fonts for other writing systems that
+                 * correspond to TrueType fonts and have matching XLFDs.
+                 * We need to register the bitmap fonts only in
+                 * environments where they're on the X font path, i.e.,
+                 * in the Japanese locale. Note that if the X Toolkit
+                 * is in use the font path isn't set up by JDK, but
+                 * users of a JA locale should have it
+                 * set up already by their login environment.
+                 */
+                if (FontUtilities.isSolaris && Locale.JAPAN.equals(Locale.getDefault())) {
+                    registerFontDir("/usr/openwin/lib/locale/ja/X11/fonts/TT");
+                }
+
                 initCompositeFonts(fontConfig, null);
 
                 return null;
@@ -2044,6 +2062,33 @@
             }
         }
 
+        /* Some apps use deprecated 1.0 names such as helvetica and courier. On
+         * Solaris these are Type1 fonts in /usr/openwin/lib/X11/fonts/Type1.
+         * If running on Solaris will register all the fonts in this
+         * directory.
+         * May as well register the whole directory without actually testing
+         * the font name is one of the deprecated names as the next step would
+         * load all fonts which are in this directory anyway.
+         * In the event that this lookup is successful it potentially "hides"
+         * TrueType versions of such fonts that are elsewhere but since they
+         * do not exist on Solaris this is not a problem.
+         * Set a flag to indicate we've done this registration to avoid
+         * repetition and more seriously, to avoid recursion.
+         */
+        if (FontUtilities.isSolaris &&!loaded1dot0Fonts) {
+            /* "timesroman" is a special case since that's not the
+             * name of any known font on Solaris or elsewhere.
+             */
+            if (lowerCaseName.equals("timesroman")) {
+                font = findFont2D("serif", style, fallback);
+                fontNameCache.put(mapName, font);
+            }
+            register1dot0Fonts();
+            loaded1dot0Fonts = true;
+            Font2D ff = findFont2D(name, style, fallback);
+            return ff;
+        }
+
         /* We check for application registered fonts before
          * explicitly loading all fonts as if necessary the registration
          * code will have done so anyway. And we don't want to needlessly
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/src/java.desktop/share/classes/sun/font/TrueTypeFont.java jdk18u-jdk-18.0.2.1-ga/src/java.desktop/share/classes/sun/font/TrueTypeFont.java
--- jdk18u-jdk-18.0.2.1-ga.orig/src/java.desktop/share/classes/sun/font/TrueTypeFont.java	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/src/java.desktop/share/classes/sun/font/TrueTypeFont.java	2024-08-17 18:29:44.511210017 +0200
@@ -229,9 +229,84 @@
         Disposer.addObjectRecord(this, disposerRecord);
     }
 
+    /* Enable natives just for fonts picked up from the platform that
+     * may have external bitmaps on Solaris. Could do this just for
+     * the fonts that are specified in font configuration files which
+     * would lighten the burden (think about that).
+     * The EBLCTag is used to skip natives for fonts that contain embedded
+     * bitmaps as there's no need to use X11 for those fonts.
+     * Skip all the latin fonts as they don't need this treatment.
+     * Further refine this to fonts that are natively accessible (ie
+     * as PCF bitmap fonts on the X11 font path).
+     * This method is called when creating the first strike for this font.
+     */
+    @Override
+    protected boolean checkUseNatives() {
+        if (checkedNatives) {
+            return useNatives;
+        }
+        if (!FontUtilities.isSolaris || useJavaRasterizer ||
+            FontUtilities.useJDKScaler || nativeNames == null ||
+            getDirectoryEntry(EBLCTag) != null ||
+            GraphicsEnvironment.isHeadless()) {
+            checkedNatives = true;
+            return false; /* useNatives is false */
+        } else if (nativeNames instanceof String) {
+            String name = (String)nativeNames;
+            /* Don't do this for Latin fonts */
+            if (name.indexOf("8859") > 0) {
+                checkedNatives = true;
+                return false;
+            } else if (NativeFont.hasExternalBitmaps(name)) {
+                nativeFonts = new NativeFont[1];
+                try {
+                    nativeFonts[0] = new NativeFont(name, true);
+                    /* If reach here we have an non-latin font that has
+                     * external bitmaps and we successfully created it.
+                     */
+                    useNatives = true;
+                } catch (FontFormatException e) {
+                    nativeFonts = null;
+                }
+            }
+        } else if (nativeNames instanceof String[]) {
+            String[] natNames = (String[])nativeNames;
+            int numNames = natNames.length;
+            boolean externalBitmaps = false;
+            for (int nn = 0; nn < numNames; nn++) {
+                if (natNames[nn].indexOf("8859") > 0) {
+                    checkedNatives = true;
+                    return false;
+                } else if (NativeFont.hasExternalBitmaps(natNames[nn])) {
+                    externalBitmaps = true;
+                }
+            }
+            if (!externalBitmaps) {
+                checkedNatives = true;
+                return false;
+            }
+            useNatives = true;
+            nativeFonts = new NativeFont[numNames];
+            for (int nn = 0; nn < numNames; nn++) {
+                try {
+                    nativeFonts[nn] = new NativeFont(natNames[nn], true);
+                } catch (FontFormatException e) {
+                    useNatives = false;
+                    nativeFonts = null;
+                }
+            }
+        }
+        if (useNatives) {
+            glyphToCharMap = new char[getMapper().getNumGlyphs()];
+        }
+        checkedNatives = true;
+        return useNatives;
+    }
+
+
     private synchronized FileChannel open() throws FontFormatException {
         return open(true);
-    }
+     }
 
     /* This is intended to be called, and the returned value used,
      * from within a block synchronized on this font object.
@@ -982,7 +1057,14 @@
             style = Font.ITALIC;
             break;
         case fsSelectionBoldBit:
-            style = Font.BOLD;
+            if (FontUtilities.isSolaris && platName.endsWith("HG-GothicB.ttf")) {
+                /* Workaround for Solaris's use of a JA font that's marked as
+                 * being designed bold, but is used as a PLAIN font.
+                 */
+                style = Font.PLAIN;
+            } else {
+                style = Font.BOLD;
+            }
             break;
         case fsSelectionBoldBit|fsSelectionItalicBit:
             style = Font.BOLD|Font.ITALIC;
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/src/java.desktop/share/classes/sun/font/Type1Font.java jdk18u-jdk-18.0.2.1-ga/src/java.desktop/share/classes/sun/font/Type1Font.java
--- jdk18u-jdk-18.0.2.1-ga.orig/src/java.desktop/share/classes/sun/font/Type1Font.java	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/src/java.desktop/share/classes/sun/font/Type1Font.java	2024-08-17 18:29:44.511771622 +0200
@@ -168,6 +168,7 @@
         throws FontFormatException {
         super(platname, nativeNames);
         fontRank = Font2D.TYPE1_RANK;
+        checkedNatives = true;
         try {
             verify();
         } catch (Throwable t) {
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/src/java.desktop/share/native/libjsound/SoundDefs.h jdk18u-jdk-18.0.2.1-ga/src/java.desktop/share/native/libjsound/SoundDefs.h
--- jdk18u-jdk-18.0.2.1-ga.orig/src/java.desktop/share/native/libjsound/SoundDefs.h	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/src/java.desktop/share/native/libjsound/SoundDefs.h	2024-08-17 18:29:44.512350490 +0200
@@ -29,9 +29,10 @@
 
 // types for X_PLATFORM
 #define X_WINDOWS       1
-#define X_LINUX         2
-#define X_BSD           3
-#define X_MACOSX        4
+#define X_SOLARIS       2
+#define X_LINUX         3
+#define X_BSD           4
+#define X_MACOSX        5
 
 // **********************************
 // Make sure you set X_PLATFORM defines correctly.
@@ -44,7 +45,7 @@
 
 
 // following is needed for _LP64
-#if ((X_PLATFORM == X_LINUX) || (X_PLATFORM == X_MACOSX))
+#if ((X_PLATFORM == X_SOLARIS) || (X_PLATFORM == X_LINUX) || (X_PLATFORM == X_MACOSX))
 #include <sys/types.h>
 #endif
 
@@ -114,6 +115,11 @@
 #endif
 
 
+#if X_PLATFORM == X_SOLARIS
+#define INLINE
+#endif
+
+
 #if X_PLATFORM == X_LINUX
 #define INLINE          inline
 #endif
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/src/java.desktop/solaris/classes/sun/font/X11CNS11643.java jdk18u-jdk-18.0.2.1-ga/src/java.desktop/solaris/classes/sun/font/X11CNS11643.java
--- jdk18u-jdk-18.0.2.1-ga.orig/src/java.desktop/solaris/classes/sun/font/X11CNS11643.java	1970-01-01 01:00:00.000000000 +0100
+++ jdk18u-jdk-18.0.2.1-ga/src/java.desktop/solaris/classes/sun/font/X11CNS11643.java	2024-08-17 18:29:44.566067764 +0200
@@ -0,0 +1,178 @@
+/*
+ * Copyright (c) 2001, 2008, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.  Oracle designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+package sun.font;
+
+import java.nio.CharBuffer;
+import java.nio.ByteBuffer;
+import java.nio.charset.*;
+import sun.nio.cs.*;
+
+public abstract class X11CNS11643 extends Charset {
+    private final int plane;
+    public X11CNS11643 (int plane, String name) {
+        super(name, null);
+        switch (plane) {
+        case 1:
+            this.plane = 0; // CS1
+            break;
+        case 2:
+        case 3:
+            this.plane = plane;
+            break;
+        default:
+            throw new IllegalArgumentException
+                ("Only planes 1, 2, and 3 supported");
+        }
+    }
+
+    public CharsetEncoder newEncoder() {
+        return new Encoder(this, plane);
+    }
+
+    public CharsetDecoder newDecoder() {
+        return new Decoder(this, plane);
+    }
+
+    public boolean contains(Charset cs) {
+        return cs instanceof X11CNS11643;
+    }
+
+    private class Encoder extends EUC_TW.Encoder {
+        private int plane;
+        public Encoder(Charset cs, int plane) {
+            super(cs);
+            this.plane = plane;
+        }
+
+        private byte[] bb = new byte[4];
+        public boolean canEncode(char c) {
+            if (c <= 0x7F) {
+                return false;
+            }
+            int nb = toEUC(c, bb);
+            if (nb == -1)
+                return false;
+            int p = 0;
+            if (nb == 4)
+                p = (bb[1] & 0xff) - 0xa0;
+            return (p == plane);
+        }
+
+        public boolean isLegalReplacement(byte[] repl) {
+            return true;
+        }
+
+        protected CoderResult encodeLoop(CharBuffer src, ByteBuffer dst) {
+            char[] sa = src.array();
+            int sp = src.arrayOffset() + src.position();
+            int sl = src.arrayOffset() + src.limit();
+            byte[] da = dst.array();
+            int dp = dst.arrayOffset() + dst.position();
+            int dl = dst.arrayOffset() + dst.limit();
+
+            try {
+                while (sp < sl) {
+                    char c = sa[sp];
+                    if ( c > '\u007f'&& c < '\uFFFE') {
+                        int nb = toEUC(c, bb);
+                        if (nb != -1) {
+                            int p = 0;
+                            if (nb == 4)
+                                p = (bb[1] & 0xff) - 0xa0;
+                            if (p == plane) {
+                                if (dl - dp < 2)
+                                    return CoderResult.OVERFLOW;
+                                if (nb == 2) {
+                                    da[dp++] = (byte)(bb[0] & 0x7f);
+                                    da[dp++] = (byte)(bb[1] & 0x7f);
+                                } else {
+                                    da[dp++] = (byte)(bb[2] & 0x7f);
+                                    da[dp++] = (byte)(bb[3] & 0x7f);
+                                }
+                                sp++;
+                                continue;
+                            }
+                        }
+                    }
+                    return CoderResult.unmappableForLength(1);
+                }
+                return CoderResult.UNDERFLOW;
+            } finally {
+                src.position(sp - src.arrayOffset());
+                dst.position(dp - dst.arrayOffset());
+            }
+        }
+    }
+
+    private class Decoder extends EUC_TW.Decoder {
+        int plane;
+        private String table;
+        protected Decoder(Charset cs, int plane) {
+            super(cs);
+            if (plane == 0)
+                this.plane = plane;
+            else if (plane == 2 || plane == 3)
+                this.plane = plane - 1;
+            else
+                throw new IllegalArgumentException
+                    ("Only planes 1, 2, and 3 supported");
+        }
+
+        //we only work on array backed buffer.
+        protected CoderResult decodeLoop(ByteBuffer src, CharBuffer dst) {
+            byte[] sa = src.array();
+            int sp = src.arrayOffset() + src.position();
+            int sl = src.arrayOffset() + src.limit();
+
+            char[] da = dst.array();
+            int dp = dst.arrayOffset() + dst.position();
+            int dl = dst.arrayOffset() + dst.limit();
+
+            try {
+                while (sp < sl) {
+                    if ( sl - sp < 2) {
+                        return CoderResult.UNDERFLOW;
+                    }
+                    int b1 = (sa[sp] & 0xff) | 0x80;
+                    int b2 = (sa[sp + 1] & 0xff) | 0x80;
+                    char[] cc = toUnicode(b1, b2, plane);
+                    // plane3 has non-bmp characters(added), x11cnsp3
+                    // however does not support them
+                    if (cc == null || cc.length == 2)
+                        return CoderResult.unmappableForLength(2);
+                    if (dl - dp < 1)
+                        return CoderResult.OVERFLOW;
+                    da[dp++] = cc[0];
+                    sp +=2;
+                }
+                return CoderResult.UNDERFLOW;
+            } finally {
+                src.position(sp - src.arrayOffset());
+                dst.position(dp - dst.arrayOffset());
+            }
+        }
+    }
+}
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/src/java.desktop/solaris/classes/sun/font/X11CNS11643P1.java jdk18u-jdk-18.0.2.1-ga/src/java.desktop/solaris/classes/sun/font/X11CNS11643P1.java
--- jdk18u-jdk-18.0.2.1-ga.orig/src/java.desktop/solaris/classes/sun/font/X11CNS11643P1.java	1970-01-01 01:00:00.000000000 +0100
+++ jdk18u-jdk-18.0.2.1-ga/src/java.desktop/solaris/classes/sun/font/X11CNS11643P1.java	2024-08-17 18:29:44.566369468 +0200
@@ -0,0 +1,33 @@
+/*
+ * Copyright (c) 1996, 2005, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.  Oracle designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+
+package sun.font;
+
+public class X11CNS11643P1 extends X11CNS11643 {
+    public X11CNS11643P1() {
+        super(1, "X11CNS11643P1");
+    }
+}
